;socket workshop
dialog sock.work {
  title "Socket Workshop"
  size -1 -1 202 156
  option dbu
  tab "Socklisten", 1, 1 1 199 138
  box "Settings", 4, 4 19 194 53, tab 1
  text "Sockname", 5, 19 30 24 8, tab 1
  edit "", 6, 44 29 66 10, tab 1 autohs
  box "", 8, 10 39 182 4, tab 1
  text "Listen Port", 9, 121 30 26 8, tab 1
  edit "", 10, 148 29 32 10, tab 1 autohs
  radio "Accept all connections", 11, 11 45 65 10, group tab 1
  radio "Decline all connections", 12, 87 45 65 10, tab 1
  radio "Ask me", 13, 164 45 30 10, tab 1
  check "Notify me of connection activity", 14, 58 60 88 10, tab 1
  list 7, 4 74 193 50, disable result tab 1 size
  button "Listen", 15, 105 126 37 11, disable tab 1
  button "Clear Fields", 16, 62 126 37 11, tab 1
  box "", 17, 10 53 182 4, tab 1
  tab "Sockopen", 2
  box "Settings", 18, 4 19 194 39, tab 2
  text "Sockname", 19, 7 30 24 8, tab 2
  edit "", 20, 32 29 57 10, tab 2 autohs
  text "IP", 21, 98 30 5 8, tab 2
  edit "", 22, 104 29 50 10, tab 2 autohs
  text "Port", 23, 157 30 11 8, tab 2
  edit "", 24, 169 29 25 10, tab 2 autohs
  box "", 25, 10 39 182 4, tab 2
  check "Echo raw data to a @window", 26, 10 46 80 10, tab 2
  check "Notify me of connection activity", 27, 105 46 86 10, tab 2
  list 28, 4 60 193 64, disable result tab 2 size
  button "Connect", 29, 105 126 37 11, disable tab 2
  button "Clear Fields", 30, 62 126 37 11, tab 2
  tab "Socklist", 3
  list 31, 4 17 194 87, tab 3 size
  box "Sockwrite", 32, 4 104 194 19, tab 3
  edit "", 33, 6 111 180 10, tab 3 autohs
  button "!", 34, 187 111 9 10, disable tab 3
  button "Close", 35, 124 126 37 11, disable tab 3
  button "Close All", 36, 83 126 37 11, disable tab 3
  button "Refresh", 37, 41 126 37 11, tab 3
  button "Exit", 38, 155 143 45 12, ok
  button "Close all and Exit", 39, 107 143 45 12
}
alias -l mdx { return $dll($scriptdirmdx.dll,$1,$2-) }
on *:dialog:sock.work:*:*:{
  if ($devent == init) {
    did -c $dname 13,14,26,27
    mdx SetMircVersion $version
    mdx MarkDialog $dname $dialog($dname).hwnd
    mdx SetControlMDX $dname 31 ListView report nosortheader showsel single grid rowselect > $scriptdirviews.mdx
    did -i $dname 31 1 headerdims 120:1 123:2 60:3 80:4
    did -i $dname 31 1 headertext Sockname $chr(9) IP $chr(9) Port $chr(9) Status
    sock.list $dname
  }
  if ($devent == edit) {
    if (($did(6)) && ($did(10))) { did -e $dname 15 }
    if ((!$did(6)) || (!$did(10))) { did -b $dname 15 }
    if (($did(20)) && ($did(22)) && ($did(24))) { did -e $dname 29 }
    if ((!$did(20)) || (!$did(22)) || (!$did(24))) { did -b $dname 29 }
  }
  if ($devent == sclick) {
    if ($did == 15) {
      did -r $dname 7
      if ($did(10) !isnum) { did -a $dname 7 Please enter proper port (any port entered MUST be a number). | halt }
      did -a $dname 7 Checking sockname and port.......
      if ($sock($did(6))) { did -a $dname 7 - Sockname checked and is IN USE. Choose another sockname. | halt }
      if (!$sock($did(6))) { did -a $dname 7 - Sockname checked and available. }
      if (!$portfree($did(10))) { did -a $dname 7 - Port checked and is NOT available. Please choose another port. | halt }
      if ($portfree($did(10))) { did -a $dname 7 - Port is checked and available. }
      did -a $dname 7 Paramaters OK, opening listen socket now...
      .socklisten $did(6) $did(10)
      .sockmark $did(6) sock.work $did(11).state $did(12).state $did(13).state $did(14).state
      did -a $dname 7 Socket listening on ip $sock($did(6)).ip $+ , and port $sock($did(6)).port $+ . Status: $sock($did(6)).status
      sock.list $dname
    }
    if ($did == 16) {
      did -r $dname 6,7,10
    }
    if ($did == 29) {
      did -r $dname 28
      if ($did(24) !isnum) { did -a $dname 28 Please enter proper port (any port entered MUST be a number). | halt }
      did -a $dname 28 Checking sockname.......
      if ($sock($did(20))) { did -a $dname 28 - Sockname checked and is IN USE. Choose another sockname. | halt }
      if (!$sock($did(20))) { did -a $dname 28 - Sockname checked and available. }
      did -a $dname 28 Paramaters OK, opening socket now...
      .sockopen $did(20) $did(22) $did(24)
      .sockmark $did(20) sock.work $did(26).state $did(27).state
      did -a $dname 28 Socket connecting to ip $sock($did(20)).ip $+ , and port $sock($did(20)).port $+ . Status: $sock($did(20)).status
      sock.list $dname
    }
    if ($did == 30) {
      did -r $dname 20,22,24
    }
    if ($did == 34) {
      sockwrite -tn $gettok($did(31).seltext,6,32) $did(33)
      did -r $dname 33
    }
    if ($did == 35) {
      .sockclose $gettok($did(31).seltext,6,32)
      if ($dialog(sock.work)) { sock.list sock.work }
    }
    if ($did == 36) {
      var %x = 1
      while ($sock(*,%x)) {
        if ($gettok($sock($sock(*,%x)).mark,1,32)) { sockclose $sock(*,%x) }
        inc %x
      }
      if ($dialog(sock.work)) { sock.list sock.work }
    }
    if ($did == 37) { sock.list $dname }
    if (($did(6)) && ($did(10))) { did -e $dname 15 }
    if ((!$did(6)) || (!$did(10))) { did -b $dname 15 }
    if (($did(20)) && ($did(22)) && ($did(24))) { did -e $dname 29 }
    if ((!$did(20)) || (!$did(22)) || (!$did(24))) { did -b $dname 29 }
    if ($did(31).seltext) {
      did -e $dname 35
      if ($sock($gettok($did(31).seltext,6,32)).status != listening) { did -e $dname 34 }
    }
    if (!$did(31).seltext) { did -b $dname 34,35 }
    if ($did == 39) {
      var %x = 1
      while ($sock(*,%x)) {
        if ($gettok($sock($sock(*,%x)).mark,1,32)) { sockclose $sock(*,%x) }
        inc %x
      }
      dialog -c sock.work
    }
  }
}
alias sock.list {
  var %y = $gettok($did($1,31).seltext,6,32)
  did -r $1 31
  var %x = 1
  while ($sock(*,%x)) {
    var %z = $ifmatch
    did -a $1 31 %z $chr(9) $sock(%z).ip $chr(9) $sock(%z).port $chr(9) $sock(%z).status
    if (%z == %y) { did -c $1 31 $calc(%x + 1) }
    inc %x
  }
  if ($did($1,31).lines > 1) { did -e $1 36 }
  if ($did($1,31).lines <= 1) { did -b $1 36 }
}
on *:socklisten:*:{
  if ($gettok($sock($sockname).mark,1,32) == sock.work) {
    if ($gettok($sock($sockname).mark,2,32)) {
      sockaccept sock.work.temp
      :again
      var %x = sock. $+ $rand(a,z) $+ $rand(a,z) $+ $rand(1,9999) $+ $rand(1,9999)
      if ($sock(%x)) { goto :again }
      if ($gettok($sock($sockname).mark,5,32)) { echo -a Socket Workshop: Auto accepted connection on port $sock($sockname).port from $sock(sock.work.temp).ip $+ . Sockname of accepted connection is %x $+ . }
      sockmark sock.work.temp sock.work CLIENT
      sockrename sock.work.temp %x
      if ($dialog(sock.work)) { sock.list sock.work }
    }
    if ($gettok($sock($sockname).mark,3,32)) {
      sockaccept sock.work.temp
      if ($gettok($sock($sockname).mark,5,32)) { echo -a Socket Workshop: Auto rejected connection on port $sock($sockname).port from $sock(sock.work.temp).ip $+ . }
      sockclose sock.work.temp
      if ($dialog(sock.work)) { sock.list sock.work }
    }
    if ($gettok($sock($sockname).mark,4,32)) {
      sockaccept sock.work.temp
      :again
      var %x = sock. $+ $rand(a,z) $+ $rand(a,z) $+ $rand(1,9999) $+ $rand(1,9999)
      if ($sock(%x)) { goto :again }
      sockmark sock.work.temp sock.work CLIENT
      sockrename sock.work.temp %x
      .timer 1 0 sock.work.ask $sockname %x
      if ($dialog(sock.work)) { sock.list sock.work }
    }
  }
}
on *:sockopen:*:{
  if ($gettok($sock($sockname).mark,1,32) == sock.work) {
    if ($sockerr > 0) {
      if ($gettok($sock($sockname).mark,3,32)) { echo -a Socket Workshop: Connection error with  $+ $sockname $+  while trying to connect to $sock($sockname).ip on port $sock($sockname).port $+ . Error: $sock($sockname).wsmsg }
      if ($dialog(sock.work)) { sock.list sock.work }
      return
    }
    if ($gettok($sock($sockname).mark,3,32)) { echo -a Socket Workshop:  $+ $sockname $+  has connected to $sock($sockname).ip on port $sock($sockname).port $+ . }
    if ($dialog(sock.work)) { sock.list sock.work }
  }
}
on *:sockread:*:{
  if ($gettok($sock($sockname).mark,1,32) == sock.work) {
    sockread %x
    if ($gettok($sock($sockname).mark,2,32)) {
      window -n $+(@,$sockname)
      aline $+(@,$sockname) %x
    }
    unset %x
  }
}
on *:sockclose:*:{
  if ($gettok($sock($sockname).mark,1,32) == sock.work) {
    if ($gettok($sock($sockname).mark,3,32)) { echo -a Socket Workshop: Connection for  $+ $sockname $+  to ip $sock($sockname).ip and port $sock($sockname).port has been lost. }
    sockclose $sockname
    if ($dialog(sock.work)) { sock.list sock.work }
  }
}
alias sockwork {
  if (!$dialog(sock.work)) { .dialog -md sock.work sock.work }
  else {
    dialog -v sock.work
  }
}
alias -l sock.work.ask {
  var %x = $input(Accept incoming connection on port $sock($1).port $+ ?,y,Socket Workshop)
  if (%x) {
    if ($gettok($sock($1).mark,5,32)) { echo -a Socket Workshop: Accepted connection on port $sock($1).port from $sock($2).ip $+ . Sockname of accepted connection is $2 $+ . }
  }
  else {
    if ($gettok($sock($1).mark,5,32)) { echo -a Socket Workshop: Rejected connection on port $sock($1).port from $sock($2).ip $+ . }
    sockclose $2
  }
  if ($dialog(sock.work)) { sock.list sock.work }
}
menu channel,menubar,query,status {
Socket Workshop:/sockwork
}
